@echo off

:start

echo ---PY2EXE START---

setlocal ENABLEDELAYEDEXPANSION

rem 初期化
set PYFILENAME=
set REPLACED_TEXT=###FILENAME###
set setupfile=setup.py
set PYFILENAME=%~n1
set FILETYPE=%~x1

set form[1]=from distutils.core import setup
set form[2]=import re,os,sys,py2exe
set form[3]=if hasattr(sys, 'setdefaultencoding'):
set form[4]=    import locale
set form[5]=    lang, enc = locale.getdefaultlocale()
set form[6]=    sys.setdefaultencoding(enc or 'cp932')
set form[7]=    del sys.setdefaultencoding
set form[8]=option = {
set form[9]=    "excludes": ['readline'],
set form[10]=    'compressed': 1,
set form[11]=     'optimize': 2,
set form[12]=    'bundle_files': 2,
set form[13]=}
set form[14]=setup(
set form[15]=    options = {'py2exe': option},
set form[16]=    console=['###FILENAME###'],
set form[17]=    zipfile = None,
set form[18]=    )


if exist setup.py (
del setup.py
)



if "%PYFILENAME%"=="" (
echo 変換対象となるpythonファイルが存在しません。
echo pythonファイルをpy2exe.batにドラッグ＆ドロップしてください。
pause
exit
)else (
if NOT "%FILETYPE%"==".py" (
echo 対象ファイルはpythonファイルではありません。
echo pythonファイルをpy2exe.batにドラッグ＆ドロップしてください。
pause
exit
)else (

    for /L %%i in (1,1,18) do ( 
        if %%i==16 (
            echo console=['%PYFILENAME%%FILETYPE%'], >> %setupfile%
        )else (
            echo !form[%%i]! >>%setupfile%
            )
    )
)
)
python setup.py py2exe
xcopy /Y dist 
rd /s /q dist

echo;
echo ---PY2EXE FINISH---
pause
exit

pause>nul